import React, { Component } from 'react';
import Taro from '@tarojs/taro';
import { View ,Picker} from '@tarojs/components'
import { getPublicReleaseList } from '../../utils/servers/servers';
import {
  AtSearchBar,
  AtTabs,
  AtTabsPane,
  AtActionSheet,
  AtActionSheetItem,
  AtIcon,
  AtList,
  AtListItem,
  AtButton
} from 'taro-ui';
import {clockState} from '../../utils/tools/config';

import './index.less';

import 'taro-ui/dist/style/components/tabs.scss';
import "taro-ui/dist/style/components/flex.scss";
import "taro-ui/dist/style/components/action-sheet.scss";
import "taro-ui/dist/style/components/icon.scss";
import "taro-ui/dist/style/components/list.scss";

import MyList from './myList';
import MessageNoticebar from "../../components/common/messageNoticebar";
import dayjs from "dayjs";
import DateTimePicker from "../../components/common/DateTimePicker";

class Examine extends Component {

  constructor(props) {
    super(props);
    this.state= {
      current: 0,

      list: [],
      pageNo: 1,
      listState: 'LOADING',

      examinelist: [],
      examinePageNo: 1,
      examineListState: 'LOADING',

      starts: {},
      clockInStarts: '',


      rangeStartVal1:'',
      rangeEndVal1:'',
      starts1:{},
      clockInStarts1:''
    }
    this.getPublicReleaseList= this.getPublicReleaseList.bind(this);
    this.getMyList= this.getMyList.bind(this);
    this.getExamineList= this.getExamineList.bind(this);
  }

  componentDidShow(){
    Taro.eventCenter.on('listOperation',(data)=>{
      if(data.type === 1 && (!isNaN(parseInt(data.index)))){
        let arr = this.state.examinelist.concat([]);
        arr[data.index] = {
          ...arr[data.index],
          ...data
        }
        this.setState({
          examinelist:arr
        })
      }else if(data.type === 0 && (!isNaN(parseInt(data.index)))){
        let arr = this.state.list.concat([]);
        arr[data.index] = {
          ...arr[data.index],
          ...data
        }
        this.setState({
          list:arr
        })
      }
    })
  }

  async componentDidMount() {
    await this.getPublicReleaseList();
  }

  onPullDownRefresh(){
    this.getPublicReleaseList();
  }

  onReachBottom(){
    this.getPublicReleaseList(true);
  }

  onTabItemTap(obj){
    if(obj.index === 1){
      this.onTabTap();
    }
  }

  async onTabTap(){
    await this.getMyList(1);
    await this.getExamineList(1);
  }

  async getPublicReleaseList (lv){
    if(this.state.current === 0){
      await this.getMyList(lv ? this.state.pageNo + 1 : 1);
      Taro.stopPullDownRefresh();
    } else if(this.state.current === 1){
      await this.getExamineList(lv ? this.state.examinePageNo + 1 : 1);
      Taro.stopPullDownRefresh();
    }
  }

  async getMyList(pageNo){
    this.setState({
      listState: 'LOADING'
    })
    let data = {
      pageNo: pageNo,
      pageSize: 10,
      type:'0',

      releaseStarts:this.state.rangeStartVal || undefined,
      releaseEnds:this.state.rangeEndVal || undefined,
      status: isNaN(parseInt(this.state.starts.id)) ? undefined : String(this.state.starts.id),
      clockIn:this.state.clockInStarts || undefined,
      userName:this.state.searchValue || undefined,
    }
    for(let i in data){
      if(!data[i]){
        delete data[i]
      }
    }
    let msg = await getPublicReleaseList(data);
    if(msg.error.length === 0){
      if(msg.data.totalCount === 0){
        this.setState({
          listState: 'NO_DATA'
        })
      }else if(msg.data.totalCount === this.state.list.length && pageNo !== 1){
        Taro.showToast({title:'没有更多数据了',icon:'none'});
        this.setState({
          listState: 'NO_MORE_DATA'
        })
      }else{
        if(msg.data.totalCount === (pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list)).length){
          this.setState({
            listState: 'NO_MORE_DATA'
          })
        }
      }
      this.setState({
        list:pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list),
        pageNo: msg.data.pageNo
      })
    }else{
      Taro.showToast({title:msg.error[0].message,icon:'none'});
      this.setState({
        listState: msg.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
      })
    }
    Taro.stopPullDownRefresh();
  }

  async getExamineList(pageNo){
    this.setState({
      examineListState: 'LOADING'
    })
    let data = {
      pageNo: pageNo,
      pageSize: 10,
      type:'1',

      releaseStarts:this.state.rangeStartVal1 || null,
      releaseEnds:this.state.rangeEndVal1 || null,
      status:isNaN(parseInt(this.state.starts1.id)) ? undefined : String(this.state.starts1.id),
      clockIn:this.state.clockInStarts1 || null,
      userName:this.state.searchValue1 || undefined,
    }
    for(let i in data){
      if(!data[i]){
        delete data[i]
      }
    }
    let msg = await getPublicReleaseList(data);
    if(msg.error.length === 0){
      if(msg.data.totalCount === 0){
        this.setState({
          examineListState: 'NO_DATA'
        })
      }else if(msg.data.totalCount === this.state.examinelist.length && pageNo !== 1){
        Taro.showToast({title:'没有更多数据了',icon:'none'});
        this.setState({
          examineListState: 'NO_MORE_DATA'
        })
      }else{
        if(msg.data.totalCount === (pageNo === 1 ? msg.data.list : this.state.examinelist.concat(msg.data.list)).length){
          this.setState({
            examineListState: 'NO_MORE_DATA'
          })
        }
      }
      this.setState({
        examinelist:pageNo === 1 ? msg.data.list : this.state.examinelist.concat(msg.data.list),
        examinePageNo: msg.data.pageNo
      })
    }else{
      Taro.showToast({title:msg.error[0].message,icon:'none'});
      this.setState({
        examineListState: msg.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
      })
    }
    Taro.stopPullDownRefresh();
  }

  render () {
    return (
      <View className='indexPage'>
        <MessageNoticebar/>
        <View className='searchContent'>
          <View className='searchTop'>
            <AtSearchBar
              showActionButton
              placeholder='请输入企业名称'
              value={this.state.current === 0 ? this.state.searchValue : this.state.searchValue1}
              actionName='更多筛选'
              onChange={(value)=>{
                if(this.state.current === 0){
                  this.setState({
                    searchValue:value
                  })
                }else{
                  this.setState({
                    searchValue1:value
                  })
                }
              }}
              onActionClick={()=>{
                this.setState({
                  openSearch:!this.state.openSearch
                })
              }}
              onConfirm={()=>{
                this.setState({
                  openSearch:false
                })
                this.getPublicReleaseList();
              }}
              onClear={()=>{
                if(this.state.current === 0){
                  this.setState({
                    searchValue:''
                  })
                }else{
                  this.setState({
                    searchValue1:''
                  })
                }
              }}
            />
          </View>
          <View className='searchBottom' style={{display:this.state.openSearch ? 'block' : 'none'}}>
            <View className='searchBottomBack' onClick={()=>{
              this.setState({
                openSearch:false
              })
            }}/>
            <View className='searchItem'>
              <Picker mode='date' onChange={(e)=>{
                if(this.state.current === 0){
                  this.setState({
                    rangeStartVal:e.detail.value,
                  })
                }else{
                  this.setState({
                    rangeStartVal1:e.detail.value,
                  })
                }
              }}>
                <AtList>
                  {
                    this.state.current === 0 ?
                      <AtListItem
                        title='开始时间'
                        hasBorder={false}
                        extraText={this.state.rangeStartVal ? this.state.rangeStartVal : '请选择开始时间'}/> :
                      <AtListItem
                        title='开始时间'
                        hasBorder={false}
                        extraText={this.state.rangeStartVal1 ? this.state.rangeStartVal1 : '请选择开始时间'}/>
                  }
                </AtList>
              </Picker>
            </View>
            <View className='searchItem'>
              <Picker mode='date' onChange={(e)=>{
                if(this.state.current === 0){
                  this.setState({
                    rangeEndVal:e.detail.value,
                  })
                }else{
                  this.setState({
                    rangeEndVal1:e.detail.value,
                  })
                }
              }}>
                <AtList>
                  {
                    this.state.current === 0 ?
                    <AtListItem
                      title='结束时间'
                      hasBorder={false}
                      extraText={this.state.rangeEndVal ? this.state.rangeEndVal : '请选择结束时间' }
                    /> :
                    <AtListItem
                      title='结束时间'
                      hasBorder={false}
                      extraText={this.state.rangeEndVal1 ? this.state.rangeEndVal1 : '请选择结束时间' }
                    />
                  }
                </AtList>
              </Picker>
            </View>
            <View className='searchItem'>
              <Picker value={this.state.current === 0 ? this.state.starts.id : this.state.starts1.id} range={clockState} rangeKey='title' mode='selector' onChange={(e)=>{
                if(this.state.current === 0){
                  this.setState({
                    starts:clockState[e.detail.value],
                  })
                }else{
                  this.setState({
                    starts1:clockState[e.detail.value],
                  })
                }
              }}>
                <AtList>
                  {
                    this.state.current === 0 ?
                      <AtListItem
                        title='审核状态'
                        hasBorder={false}
                        extraText={this.state.starts.title ? this.state.starts.title : '请选择审核状态'}/> :
                      <AtListItem
                        title='审核状态'
                        hasBorder={false}
                        extraText={this.state.starts1.title ? this.state.starts1.title : '请选择审核状态'}/>
                  }
                </AtList>
              </Picker>
            </View>
            <View className='searchItem'>
              <Picker value={this.state.current === 0 ? this.state.clockInStarts : this.state.clockInStarts1} range={[
                '未打卡',
                '已打卡'
              ]} mode='selector' onChange={(e)=>{
                if(this.state.current === 0){
                  this.setState({
                    clockInStarts:String(e.detail.value)
                  })
                }else{
                  this.setState({
                    clockInStarts1:String(e.detail.value)
                  })
                }
              }}>
                <AtList>
                  {
                    this.state.current === 0 ?
                      <AtListItem
                        title='打卡状态'
                        hasBorder={false}
                        extraText={
                          this.state.clockInStarts === '1' ? '已打卡' :
                            this.state.clockInStarts === '0' ? '未打卡' :'请选择打卡状态'
                        }/>:
                      <AtListItem
                        title='打卡状态'
                        hasBorder={false}
                        extraText={
                          this.state.clockInStarts1 === '1' ? '已打卡' :
                            this.state.clockInStarts1 === '0' ? '未打卡' :'请选择打卡状态'
                        }/>
                  }
                </AtList>
              </Picker>
            </View>
            <View className='searchOperation'>
              <View className='reset' onClick={()=>{
                if(this.state.current === 0){
                  this.setState({
                    rangeStartVal:'',
                    rangeEndVal:'',
                    starts:{},
                    clockInStarts:'',
                    openSearch:false,
                    searchValue:''
                  },()=>{
                    this.getPublicReleaseList();
                  })
                }else{
                  this.setState({
                    rangeStartVal1:'',
                    rangeEndVal1:'',
                    starts1:{},
                    clockInStarts1:'',
                    openSearch:false,
                    searchValue1:''
                  },()=>{
                    this.getPublicReleaseList();
                  })
                }
              }}>重置</View>
              <View className='search' onClick={()=>{
                this.setState({
                  openSearch:false
                })
                this.getPublicReleaseList();
              }}>搜索</View>
            </View>
          </View>
        </View>
        <AtTabs current={this.state.current || 0} tabList={[{ title: '我的' }, { title: '审核' }]} onClick={(current)=>{
          this.setState({
            current
          },()=>{
            if((current === 0 && this.state.pageNo === 1) || (current === 1 && this.state.examinePageNo === 1)){
              this.getPublicReleaseList();
            }
          })
        }}>
          <AtTabsPane current={this.state.current} index={0} >
            <MyList
              type={0}
              list={this.state.list}
              listState={this.state.listState}
              onRefresh={()=>{
                this.getPublicReleaseList(true);
              }}/>
          </AtTabsPane>
          <AtTabsPane current={this.state.current} index={1}>
            <MyList
              type={1}
              list={this.state.examinelist}
              listState={this.state.examineListState}
              onRefresh={()=>{
                this.getPublicReleaseList(true);
              }}/>
          </AtTabsPane>
        </AtTabs>
      </View>
    )
  }
}

export default Examine
